"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactstrap = require("reactstrap");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// used for making the prop types of this component


var Accordion = function (_React$Component) {
  _inherits(Accordion, _React$Component);

  function Accordion(props) {
    _classCallCheck(this, Accordion);

    var _this = _possibleConstructorReturn(this, (Accordion.__proto__ || Object.getPrototypeOf(Accordion)).call(this, props));

    _this.state = {
      open: _this.props.defaultOpened !== undefined ? _this.props.defaultOpened : -1
    };
    return _this;
  }

  _createClass(Accordion, [{
    key: "openCollapse",
    value: function openCollapse(number) {
      if (this.state.open !== -1) {
        this.refs["collapse" + this.state.open].classList.toggle("expanded");
      }
      this.state.open === number ? this.setState({ open: -1 }) : this.setState({ open: number });
      this.refs["collapse" + number].classList.toggle("expanded");
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        "div",
        { className: "card-collapse" },
        this.props.components.map(function (prop, key) {
          return _react2.default.createElement(
            _reactstrap.Card,
            { className: _this2.props.plain ? "card-plain" : "", key: key },
            _react2.default.createElement(
              _reactstrap.CardHeader,
              null,
              _react2.default.createElement(
                "a",
                {
                  "data-toggle": "collapse",
                  "aria-expanded": _this2.state.open === key ? true : false,
                  className: _this2.state.open === key ? "expanded" : "",
                  ref: "collapse" + key,
                  onClick: function onClick() {
                    return _this2.openCollapse(key);
                  }
                },
                prop.title,
                _react2.default.createElement("i", { className: "now-ui-icons arrows-1_minimal-down" })
              )
            ),
            _react2.default.createElement(
              _reactstrap.Collapse,
              { isOpen: _this2.state.open === key ? true : false },
              _react2.default.createElement(
                _reactstrap.CardBody,
                null,
                prop.text
              )
            )
          );
        })
      );
    }
  }]);

  return Accordion;
}(_react2.default.Component);

Accordion.propTypes = {
  // Which one of the component will be opened by default
  defaultOpened: _propTypes2.default.number,
  // The Accordion will have no background color
  plain: _propTypes2.default.bool,
  // example: [{title: "Title of the Collapse", text: "Text/Body of the Collapse"}]
  components: _propTypes2.default.arrayOf(_propTypes2.default.object)
};

exports.default = Accordion;