'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _FontAwesome = require('../FontAwesome/FontAwesome');

var _FontAwesome2 = _interopRequireDefault(_FontAwesome);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FieldGroup = function (_Component) {
  _inherits(FieldGroup, _Component);

  function FieldGroup(props) {
    _classCallCheck(this, FieldGroup);

    var _this = _possibleConstructorReturn(this, (FieldGroup.__proto__ || Object.getPrototypeOf(FieldGroup)).call(this, props));

    _this.state = {
      focus: false,
      showPassword: false
    };
    return _this;
  }

  _createClass(FieldGroup, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          label = _props.label,
          onChange = _props.onChange,
          addonLeft = _props.addonLeft,
          addonRight = _props.addonRight,
          formGroupProps = _props.formGroupProps,
          labelProps = _props.labelProps,
          inputProps = _props.inputProps,
          inputGroupProps = _props.inputGroupProps,
          inputGroupAddonProps = _props.inputGroupAddonProps;

      var classes = ' ';
      if (inputGroupProps !== undefined) {
        if (inputGroupProps.className !== undefined) {
          classes += inputGroupProps.className + ' ';
        }
      }
      if (addonLeft !== undefined || addonRight !== undefined) {
        return _react2.default.createElement(
          _reactstrap.InputGroup,
          _extends({}, inputGroupProps, {
            className: classes + (this.state.focus ? 'input-group-focus' : '')
          }),
          addonLeft !== undefined ? _react2.default.createElement(
            _reactstrap.InputGroupAddon,
            inputGroupAddonProps,
            addonLeft
          ) : '',
          _react2.default.createElement(_reactstrap.Input, _extends({}, inputProps, {
            onFocus: function onFocus() {
              return _this2.setState({ focus: true });
            },
            onBlur: function onBlur() {
              return _this2.setState({ focus: false });
            }
          })),
          addonRight !== undefined ? _react2.default.createElement(
            _reactstrap.InputGroupAddon,
            inputGroupAddonProps,
            addonRight
          ) : ''
        );
      } else if (inputProps.type === 'password') {
        return _react2.default.createElement(
          _reactstrap.FormGroup,
          formGroupProps,
          label ? _react2.default.createElement(
            _reactstrap.Label,
            labelProps,
            label,
            '  ',
            _react2.default.createElement(_FontAwesome2.default, {
              onClick: function onClick() {
                return _this2.setState({ showPassword: !_this2.state.showPassword });
              },
              icon: 'mt-3 ' + (this.state.showPassword ? 'fas fa-eye-slash ' : 'fas fa-eye')
            })
          ) : '',
          _react2.default.createElement(_reactstrap.Input, _extends({}, inputProps, {
            type: this.state.showPassword ? 'text' : 'password',
            onFocus: function onFocus() {
              return _this2.setState({ focus: true });
            },
            onBlur: function onBlur() {
              return _this2.setState({ focus: false });
            }
          }))
        );
      }
      return inputProps.type === 'radio' || inputProps.type === 'checkbox' ? _react2.default.createElement(
        _reactstrap.FormGroup,
        _extends({}, formGroupProps, {
          className: inputProps.type === 'radio' ? 'form-check-radio' : ''
        }),
        _react2.default.createElement(
          _reactstrap.Label,
          labelProps,
          _react2.default.createElement(_reactstrap.Input, inputProps),
          _react2.default.createElement('span', { className: 'form-check-sign' }),
          label || ''
        )
      ) : _react2.default.createElement(
        _reactstrap.FormGroup,
        formGroupProps,
        label ? _react2.default.createElement(
          _reactstrap.Label,
          labelProps,
          label
        ) : '',
        _react2.default.createElement(_reactstrap.Input, inputProps)
      );
    }
  }]);

  return FieldGroup;
}(_react.Component);

FieldGroup.propTypes = {
  label: _propTypes2.default.string,
  addonLeft: _propTypes2.default.any,
  addonRight: _propTypes2.default.any,
  formGroupProps: _propTypes2.default.any,
  labelProps: _propTypes2.default.any,
  inputProps: _propTypes2.default.any,
  inputGroupAddonProps: _propTypes2.default.any,
  inputGroupProps: _propTypes2.default.any
};

FieldGroup.defaultProps = {};

exports.default = FieldGroup;