'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _FontAwesome = require('../FontAwesome/FontAwesome');

var _FontAwesome2 = _interopRequireDefault(_FontAwesome);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Header = function (_React$Component) {
  _inherits(Header, _React$Component);

  function Header(props) {
    _classCallCheck(this, Header);

    var _this = _possibleConstructorReturn(this, (Header.__proto__ || Object.getPrototypeOf(Header)).call(this, props));

    _this.state = {
      isOpen: false,
      color: 'white'
    };

    _this.toggle = _this.toggle.bind(_this);
    return _this;
  }

  _createClass(Header, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('resize', this.updateColor.bind(this));
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(e) {
      if (window.innerWidth < 993 && e.history.location.pathname !== e.location.pathname && document.documentElement.className.indexOf('nav-open') !== -1) {
        var container = document.querySelector('#sidebarToggle');

        document.documentElement.classList.toggle('nav-open');
        container.classList.toggle('toggled');
      }
    }
  }, {
    key: 'toggle',
    value: function toggle() {
      if (this.state.isOpen) {
        this.setState({
          color: 'white'
        });
      } else {
        this.setState({
          color: 'white'
        });
      }
      this.setState({
        isOpen: !this.state.isOpen
      });
    }
  }, {
    key: 'openSidebar',
    value: function openSidebar() {
      var container = document.querySelector('#sidebarToggle');

      document.documentElement.classList.toggle('nav-open');
      container.classList.toggle('toggled');
    }
    // function that adds color white/transparent to the navbar on resize (this is for the collapse)

  }, {
    key: 'updateColor',
    value: function updateColor() {
      if (window.innerWidth < 993 && this.state.isOpen) {
        this.setState({
          color: 'white'
        });
      } else {
        this.setState({
          color: 'white'
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          location = _props.location,
          title = _props.title,
          searchPlaceholder = _props.searchPlaceholder,
          children = _props.children,
          history = _props.history,
          icon = _props.icon,
          path = _props.path;

      return _react2.default.createElement(
        _reactstrap.Navbar,
        {
          color: location && history && location.pathname.indexOf('full-screen') !== -1 ? 'white' : this.state.color,
          expand: 'lg',
          className: location.pathname.indexOf('full-screen') !== -1 ? 'navbar-absolute fixed-top' : 'navbar-absolute fixed-top ' + (this.state.color === 'transparent' ? 'navbar-transparent ' : '')
        },
        _react2.default.createElement(
          _reactstrap.Container,
          { fluid: true },
          _react2.default.createElement(
            'div',
            { className: 'navbar-wrapper' },
            _react2.default.createElement(
              'div',
              { className: 'navbar-toggle' },
              _react2.default.createElement(
                'button',
                {
                  type: 'button',
                  id: 'sidebarToggle',
                  className: 'navbar-toggler',
                  onClick: function onClick() {
                    return _this2.openSidebar();
                  }
                },
                _react2.default.createElement('span', { className: 'navbar-toggler-bar bar1' }),
                _react2.default.createElement('span', { className: 'navbar-toggler-bar bar2' }),
                _react2.default.createElement('span', { className: 'navbar-toggler-bar bar3' })
              )
            ),
            _react2.default.createElement(
              _reactstrap.NavbarBrand,
              { href: path, className: 'grow' },
              _react2.default.createElement(_FontAwesome2.default, { icon: icon }),
              ' ',
              title
            )
          ),
          _react2.default.createElement(
            _reactstrap.NavbarToggler,
            { onClick: this.toggle },
            _react2.default.createElement('span', { className: 'navbar-toggler-bar navbar-kebab' }),
            _react2.default.createElement('span', { className: 'navbar-toggler-bar navbar-kebab' }),
            _react2.default.createElement('span', { className: 'navbar-toggler-bar navbar-kebab' })
          ),
          _react2.default.createElement(
            _reactstrap.Collapse,
            { isOpen: this.state.isOpen, navbar: true, className: 'justify-content-end' },
            searchPlaceholder && _react2.default.createElement(
              'form',
              null,
              _react2.default.createElement(
                _reactstrap.InputGroup,
                { className: 'no-border' },
                _react2.default.createElement(_reactstrap.Input, { placeholder: searchPlaceholder }),
                _react2.default.createElement(
                  _reactstrap.InputGroupAddon,
                  { addonType: 'append', className: 'input-group-addon' },
                  _react2.default.createElement(_FontAwesome2.default, { icon: 'fas fa-search' })
                )
              )
            ),
            _react2.default.createElement(
              _reactstrap.Nav,
              { navbar: true },
              children
            )
          )
        )
      );
    }
  }]);

  return Header;
}(_react2.default.Component);

Header.propTypes = {
  location: _propTypes2.default.object.isRequired,
  history: _propTypes2.default.object.isRequired,
  title: _propTypes2.default.string,
  icon: _propTypes2.default.string,
  searchPlaceholder: _propTypes2.default.string,
  children: _propTypes2.default.any,
  path: _propTypes2.default.string
};

Header.defaultProps = {
  path: '/'
};

exports.default = Header;