'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var moment = require('moment');

var CURRENCY = 'currency';
var TEXT = 'text';
var DATE = 'date';

var LabelDataTable = function (_Component) {
  _inherits(LabelDataTable, _Component);

  function LabelDataTable() {
    _classCallCheck(this, LabelDataTable);

    return _possibleConstructorReturn(this, (LabelDataTable.__proto__ || Object.getPrototypeOf(LabelDataTable)).apply(this, arguments));
  }

  _createClass(LabelDataTable, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          text = _props.text,
          value = _props.value,
          type = _props.type;


      var valueType = function valueType() {
        if (type === TEXT) return value;
        if (type === CURRENCY) return 'R$ ' + value;
        if (type === DATE) return moment(value).format('DD/MM/YYYY');
        return null;
      };

      var Label = _styledComponents2.default.div.withConfig({
        displayName: 'LabelDataTable__Label',
        componentId: 'sc-6u0mi1-0'
      })(['font-size:0.9em;color:#a1a1a1;']);

      var Value = _styledComponents2.default.div.withConfig({
        displayName: 'LabelDataTable__Value',
        componentId: 'sc-6u0mi1-1'
      })(['font-size:1.1em;']);

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          Label,
          { className: 'text-uppercase' },
          text
        ),
        _react2.default.createElement(
          Value,
          null,
          valueType()
        )
      );
    }
  }]);

  return LabelDataTable;
}(_react.Component);

LabelDataTable.propTypes = {
  text: _propTypes2.default.any,
  value: _propTypes2.default.any,
  type: _propTypes2.default.oneOf([TEXT, CURRENCY, DATE])
};

LabelDataTable.defaultProps = {
  value: '',
  type: TEXT
};

exports.default = LabelDataTable;