'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _reactstrap = require('reactstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SectionCard = function (_React$Component) {
  _inherits(SectionCard, _React$Component);

  function SectionCard() {
    _classCallCheck(this, SectionCard);

    return _possibleConstructorReturn(this, (SectionCard.__proto__ || Object.getPrototypeOf(SectionCard)).apply(this, arguments));
  }

  _createClass(SectionCard, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          src = _props.src,
          children = _props.children,
          alt = _props.alt,
          footer = _props.footer,
          className = _props.className,
          to = _props.to,
          lg = _props.lg,
          md = _props.md,
          xs = _props.xs,
          fluid = _props.fluid,
          onClick = _props.onClick,
          tag = _props.tag,
          backgroundColor = _props.backgroundColor;

      var Builder = function Builder() {
        var DefaultCard = function DefaultCard() {
          return _react2.default.createElement(
            _reactstrap.Card,
            {
              tag: tag,
              className: 'card-animated section-card ' + className,
              onClick: onClick,
              style: { backgroundColor: backgroundColor }
            },
            _react2.default.createElement(
              _reactstrap.CardBody,
              { className: 'text-center' },
              _react2.default.createElement(
                'h6',
                { className: 'my-3' },
                children
              ),
              _react2.default.createElement('img', { src: src, alt: alt })
            ),
            _react2.default.createElement(
              _reactstrap.CardFooter,
              { className: 'text-center' },
              footer
            )
          );
        };

        var CardWithLink = function CardWithLink() {
          return to ? _react2.default.createElement(
            _reactRouterDom.Link,
            { to: to },
            _react2.default.createElement(DefaultCard, null)
          ) : _react2.default.createElement(DefaultCard, null);
        };

        var CardBuilded = function CardBuilded() {
          return _react2.default.createElement(CardWithLink, null);
        };

        return _react2.default.createElement(CardBuilded, null);
      };

      return fluid ? _react2.default.createElement(Builder, null) : _react2.default.createElement(
        _reactstrap.Col,
        { lg: lg, md: md, xs: xs },
        _react2.default.createElement(Builder, null)
      );
    }
  }]);

  return SectionCard;
}(_react2.default.Component);

SectionCard.propTypes = {
  extended: _propTypes2.default.bool,
  backgroundColor: _propTypes2.default.string,
  children: _propTypes2.default.any,
  footer: _propTypes2.default.any,
  to: _propTypes2.default.string,
  src: _propTypes2.default.any,
  alt: _propTypes2.default.string,
  fluid: _propTypes2.default.bool,
  lg: _propTypes2.default.number,
  md: _propTypes2.default.number,
  xs: _propTypes2.default.number,
  className: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  tag: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string])
};

SectionCard.defaultProps = {
  extended: false,
  backgroundColor: '',
  footer: null,
  fluid: false,
  lg: 3,
  md: 6,
  xs: 12,
  onClick: null
};

exports.default = SectionCard;