'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

var _FontAwesome = require('../FontAwesome/FontAwesome');

var _FontAwesome2 = _interopRequireDefault(_FontAwesome);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MenuItemSidebar = function (_React$Component) {
  _inherits(MenuItemSidebar, _React$Component);

  function MenuItemSidebar() {
    _classCallCheck(this, MenuItemSidebar);

    return _possibleConstructorReturn(this, (MenuItemSidebar.__proto__ || Object.getPrototypeOf(MenuItemSidebar)).apply(this, arguments));
  }

  _createClass(MenuItemSidebar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          icon = _props.icon,
          children = _props.children,
          label = _props.label,
          mini = _props.mini,
          to = _props.to,
          active = _props.active,
          tag = _props.tag,
          onClick = _props.onClick;

      return _react2.default.createElement(
        'li',
        { className: active ? 'active' : '' },
        _react2.default.createElement(
          _reactRouterDom.NavLink,
          { onClick: onClick, tag: tag, to: to, activeClassName: 'active' },
          _react2.default.createElement(
            'span',
            { className: 'sidebar-mini-icon' },
            icon && _react2.default.createElement(_FontAwesome2.default, { icon: icon }),
            mini
          ),
          _react2.default.createElement(
            'span',
            { className: 'sidebar-normal' },
            label,
            children
          )
        )
      );
    }
  }]);

  return MenuItemSidebar;
}(_react2.default.Component);

MenuItemSidebar.propTypes = {
  onClick: _propTypes2.default.func,
  tag: _propTypes2.default.string,
  icon: _propTypes2.default.string,
  mini: _propTypes2.default.string,
  label: _propTypes2.default.string,
  to: _propTypes2.default.string,
  active: _propTypes2.default.bool,
  children: _propTypes2.default.any
};

MenuItemSidebar.defaultProps = {
  onClick: function onClick() {
    return null;
  },
  icon: '',
  mini: '',
  label: '',
  to: '/'
};

exports.default = MenuItemSidebar;