'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _reactstrap = require('reactstrap');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FontAwesome = require('../FontAwesome/FontAwesome');

var _FontAwesome2 = _interopRequireDefault(_FontAwesome);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// used for making the prop types of this component


var MenuNavSidebar = function (_React$Component) {
  _inherits(MenuNavSidebar, _React$Component);

  function MenuNavSidebar(props) {
    _classCallCheck(this, MenuNavSidebar);

    var _this = _possibleConstructorReturn(this, (MenuNavSidebar.__proto__ || Object.getPrototypeOf(MenuNavSidebar)).call(this, props));

    _this.state = {
      isOpen: props.isOpen
    };
    return _this;
  }

  _createClass(MenuNavSidebar, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          active = _props.active,
          label = _props.label,
          icon = _props.icon,
          to = _props.to;

      return _react2.default.createElement(
        'li',
        { className: active ? 'active' : '' },
        children ? _react2.default.createElement(
          'a',
          {
            'data-toggle': 'collapse',
            'aria-expanded': this.state.isOpen,
            onClick: function onClick() {
              return _this2.setState({ isOpen: !_this2.state.isOpen });
            }
          },
          _react2.default.createElement(_FontAwesome2.default, { icon: icon }),
          _react2.default.createElement(
            'p',
            null,
            label,
            children && _react2.default.createElement('b', { className: 'caret' })
          )
        ) : _react2.default.createElement(
          _reactRouterDom.NavLink,
          { to: to },
          icon && _react2.default.createElement(_FontAwesome2.default, { icon: icon }),
          _react2.default.createElement(
            'p',
            null,
            label
          )
        ),
        children && _react2.default.createElement(
          _reactstrap.Collapse,
          { isOpen: this.state.isOpen },
          _react2.default.createElement(
            'ul',
            { className: 'nav' },
            children
          )
        )
      );
    }
  }]);

  return MenuNavSidebar;
}(_react2.default.Component);

MenuNavSidebar.propTypes = {
  isOpen: _propTypes2.default.bool,
  active: _propTypes2.default.bool,
  children: _propTypes2.default.any,
  label: _propTypes2.default.string,
  to: _propTypes2.default.string,
  icon: _propTypes2.default.string
};

MenuNavSidebar.defaultProps = {
  isOpen: false,
  active: false
};

exports.default = MenuNavSidebar;