'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _perfectScrollbar = require('perfect-scrollbar');

var _perfectScrollbar2 = _interopRequireDefault(_perfectScrollbar);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactstrap = require('reactstrap');

var _CustomButton = require('../CustomButton/CustomButton');

var _CustomButton2 = _interopRequireDefault(_CustomButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ps = void 0;

var Sidebar = function (_React$Component) {
  _inherits(Sidebar, _React$Component);

  function Sidebar(props) {
    _classCallCheck(this, Sidebar);

    var _this = _possibleConstructorReturn(this, (Sidebar.__proto__ || Object.getPrototypeOf(Sidebar)).call(this, props));

    _this.minimizeSidebar = _this.minimizeSidebar.bind(_this);
    return _this;
  }

  _createClass(Sidebar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (navigator.platform.indexOf('Win') > -1) {
        var container = document.querySelector('#sidebar');
        ps = new _perfectScrollbar2.default(container, {
          suppressScrollX: true,
          suppressScrollY: false
        });
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (navigator.platform.indexOf('Win') > -1) {
        ps.update();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (navigator.platform.indexOf('Win') > -1) {
        ps.destroy();
      }
    }
  }, {
    key: 'minimizeSidebar',
    value: function minimizeSidebar() {
      document.body.classList.toggle('sidebar-mini');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          logo = _props.logo,
          color = _props.color,
          user = _props.user,
          children = _props.children;


      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { className: 'sidebar', 'data-color': color },
          _react2.default.createElement(
            'div',
            { className: 'logo' },
            _react2.default.createElement(
              'a',
              { href: logo && logo.url, className: 'simple-text logo-mini' },
              _react2.default.createElement(
                'div',
                { className: 'logo-img' },
                _react2.default.createElement('img', { src: logo && logo.image, alt: logo && logo.text })
              )
            ),
            _react2.default.createElement(
              'a',
              { href: logo && logo.url, className: 'simple-text logo-normal' },
              logo && logo.text
            ),
            _react2.default.createElement(
              'div',
              { className: 'navbar-minimize' },
              _react2.default.createElement(
                _CustomButton2.default,
                {
                  simple: true,
                  neutral: true,
                  icon: true,
                  round: true,
                  id: 'minimizeSidebar',
                  onClick: this.minimizeSidebar },
                _react2.default.createElement('i', { className: 'fas fa-ellipsis-v visible-on-sidebar-regular' }),
                _react2.default.createElement('i', { className: 'fas fa-bars visible-on-sidebar-mini' })
              )
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'sidebar-wrapper', id: 'sidebar' },
            user,
            _react2.default.createElement(
              _reactstrap.Nav,
              null,
              children
            )
          )
        )
      );
    }
  }]);

  return Sidebar;
}(_react2.default.Component);

Sidebar.propTypes = {
  logo: _propTypes2.default.object,
  color: _propTypes2.default.string,
  user: _propTypes2.default.element,
  children: _propTypes2.default.any
};

Sidebar.defaultProps = {
  logo: null,
  color: 'blue',
  user: null,
  children: null
};

exports.default = Sidebar;