'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactstrap = require('reactstrap');

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _FontAwesome = require('../FontAwesome/FontAwesome');

var _FontAwesome2 = _interopRequireDefault(_FontAwesome);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CustomButton = _styledComponents2.default.a.withConfig({
  displayName: 'Item__CustomButton',
  componentId: 'b24k7w-0'
})(['cursor:pointer;']);

var Item = function (_Component) {
  _inherits(Item, _Component);

  function Item(props) {
    _classCallCheck(this, Item);

    var _this = _possibleConstructorReturn(this, (Item.__proto__ || Object.getPrototypeOf(Item)).call(this, props));

    _this.state = {
      modal: false
    };

    _this.toggleModal = _this.toggleModal.bind(_this);
    return _this;
  }

  _createClass(Item, [{
    key: 'toggleModal',
    value: function toggleModal() {
      var _props = this.props,
          item = _props.item,
          onRead = _props.onRead;


      if (this.state.modal && !item.checked) {
        onRead(item.id);
      }

      this.setState({ modal: !this.state.modal });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          simple = _props2.simple,
          checkedText = _props2.checkedText,
          closeText = _props2.closeText,
          item = _props2.item;


      return _react2.default.createElement(
        'li',
        { className: !simple ? item.inverted ? 'timeline-inverted' : '' : 'timeline-inverted' },
        item.badgeColor ? _react2.default.createElement(
          'div',
          { className: 'timeline-badge ' + item.badgeColor },
          item.authorPicture ? _react2.default.createElement('img', { src: item.authorPicture, alt: item.title, className: 'avatar' }) : _react2.default.createElement(_FontAwesome2.default, { icon: item.badgeIcon })
        ) : null,
        _react2.default.createElement(
          'div',
          { className: 'timeline-panel card-animated' },
          _react2.default.createElement(
            CustomButton,
            { onClick: this.toggleModal },
            _react2.default.createElement(
              'div',
              { className: 'timeline-heading' },
              item.title && _react2.default.createElement(
                'h5',
                null,
                item.title
              ),
              item.category ? _react2.default.createElement(
                'span',
                { className: 'badge badge-' + item.titleColor },
                _react2.default.createElement(_FontAwesome2.default, { icon: item.badgeIcon }),
                ' ',
                item.category
              ) : null
            ),
            _react2.default.createElement(
              'div',
              { className: 'timeline-body' },
              item.resume
            ),
            _react2.default.createElement('hr', null),
            item.publishedDate ? _react2.default.createElement(
              _reactstrap.Row,
              null,
              _react2.default.createElement(
                _reactstrap.Col,
                { xs: 4 },
                _react2.default.createElement(
                  'h6',
                  { className: 'text-left' },
                  _react2.default.createElement(_FontAwesome2.default, { icon: 'far fa-calendar-alt' }),
                  ' ',
                  item.publishedDate
                )
              ),
              _react2.default.createElement(
                _reactstrap.Col,
                { xs: 4 },
                _react2.default.createElement(
                  'h6',
                  { className: 'text-center' },
                  _react2.default.createElement(_FontAwesome2.default, { icon: 'far fa-user' }),
                  ' ',
                  item.publishedAuthor
                )
              ),
              _react2.default.createElement(
                _reactstrap.Col,
                { xs: 4 },
                item.checked && _react2.default.createElement(
                  'h6',
                  { className: 'text-right' },
                  _react2.default.createElement(_FontAwesome2.default, { icon: 'far fa-check-circle' }),
                  ' ',
                  checkedText
                )
              )
            ) : null,
            item.footer ? _react2.default.createElement(
              'div',
              { className: 'timeline-footer' },
              item.footer
            ) : null
          ),
          _react2.default.createElement(
            _reactstrap.Modal,
            { isOpen: this.state.modal, toggle: this.toggleModal, size: 'xl' },
            _react2.default.createElement(
              _reactstrap.ModalHeader,
              { toggle: this.toggleModal },
              item.title,
              ' ',
              item.category ? _react2.default.createElement(
                'span',
                { className: 'badge badge-' + item.titleColor },
                _react2.default.createElement(_FontAwesome2.default, { icon: item.badgeIcon }),
                ' ',
                item.category
              ) : null
            ),
            _react2.default.createElement(
              _reactstrap.ModalBody,
              null,
              _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: item.body } }),
              _react2.default.createElement('hr', null),
              _react2.default.createElement(
                _reactstrap.Row,
                null,
                _react2.default.createElement(
                  _reactstrap.Col,
                  { xs: 4 },
                  _react2.default.createElement(
                    'h6',
                    { className: 'text-left' },
                    _react2.default.createElement(_FontAwesome2.default, { icon: 'far fa-calendar-alt' }),
                    ' ',
                    item.publishedDate
                  )
                ),
                _react2.default.createElement(
                  _reactstrap.Col,
                  { xs: 4 },
                  _react2.default.createElement(
                    'h6',
                    { className: 'text-center' },
                    _react2.default.createElement(_FontAwesome2.default, { icon: 'far fa-user' }),
                    ' ',
                    item.publishedAuthor
                  )
                ),
                _react2.default.createElement(
                  _reactstrap.Col,
                  { xs: 4 },
                  item.checked && _react2.default.createElement(
                    'h6',
                    { className: 'text-right' },
                    _react2.default.createElement(_FontAwesome2.default, { icon: 'far fa-check-circle' }),
                    ' ',
                    checkedText
                  )
                )
              )
            ),
            _react2.default.createElement(
              _reactstrap.ModalFooter,
              null,
              _react2.default.createElement(
                _reactstrap.Button,
                { onClick: this.toggleModal, className: 'btn-simple' },
                _react2.default.createElement(_FontAwesome2.default, { icon: 'fas fa-times' }),
                ' ',
                closeText
              )
            )
          )
        )
      );
    }
  }]);

  return Item;
}(_react.Component);

Item.propTypes = {
  simple: _propTypes2.default.bool,
  checkedText: _propTypes2.default.string,
  closeText: _propTypes2.default.string,
  onRead: _propTypes2.default.func,
  id: _propTypes2.default.any,
  item: _propTypes2.default.object
};

Item.defaultProps = {
  checkedText: 'Já lido',
  closeText: 'Fechar'
};

exports.default = Item;