'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDropzone = require('react-dropzone');

var _reactDropzone2 = _interopRequireDefault(_reactDropzone);

var _reactstrap = require('reactstrap');

var _FontAwesome = require('../FontAwesome/FontAwesome');

var _FontAwesome2 = _interopRequireDefault(_FontAwesome);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MediaLibraryDropzone = function (_React$Component) {
  _inherits(MediaLibraryDropzone, _React$Component);

  function MediaLibraryDropzone() {
    _classCallCheck(this, MediaLibraryDropzone);

    return _possibleConstructorReturn(this, (MediaLibraryDropzone.__proto__ || Object.getPrototypeOf(MediaLibraryDropzone)).apply(this, arguments));
  }

  _createClass(MediaLibraryDropzone, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          accepted = _props.accepted,
          rejected = _props.rejected,
          multiple = _props.multiple,
          uploadZoneIcon = _props.uploadZoneIcon,
          accept = _props.accept,
          style = _props.style,
          dropZoneText = _props.dropZoneText,
          confirmUploadTitle = _props.confirmUploadTitle,
          cancelButtonText = _props.cancelButtonText,
          confirmButtonText = _props.confirmButtonText,
          modalClassName = _props.modalClassName,
          rejectedFilesWarning = _props.rejectedFilesWarning,
          onSave = _props.onSave,
          onDrop = _props.onDrop,
          onClick = _props.onClick,
          toggleModal = _props.toggleModal,
          modalStatus = _props.modalStatus;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _reactDropzone2.default,
          {
            multiple: multiple,
            accept: accept,
            onDrop: onDrop,
            onClick: onClick,
            style: style
          },
          _react2.default.createElement(
            'center',
            null,
            _react2.default.createElement(_FontAwesome2.default, { icon: uploadZoneIcon }),
            _react2.default.createElement(
              'div',
              null,
              dropZoneText
            )
          )
        ),
        accepted.length > 0 && _react2.default.createElement(
          _reactstrap.Modal,
          { isOpen: modalStatus, toggle: toggleModal, modalClassName: modalClassName },
          _react2.default.createElement(
            _reactstrap.ModalHeader,
            { toggle: toggleModal },
            confirmUploadTitle
          ),
          _react2.default.createElement(
            _reactstrap.ModalBody,
            null,
            accepted.map(function (file) {
              return _react2.default.createElement(
                'div',
                { key: file.name },
                _react2.default.createElement(_FontAwesome2.default, { icon: 'far fa-file' }),
                ' ',
                _react2.default.createElement(
                  'strong',
                  null,
                  file.name
                ),
                ' ',
                _react2.default.createElement(
                  _reactstrap.Badge,
                  { color: 'success' },
                  (file.size / 1000).toFixed(1),
                  'kb'
                )
              );
            }),
            rejected.length > 0 && _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement('hr', null),
              rejectedFilesWarning,
              rejected.map(function (file) {
                return _react2.default.createElement(
                  'div',
                  { key: file.name },
                  _react2.default.createElement(_FontAwesome2.default, { icon: 'far fa-file' }),
                  ' ',
                  _react2.default.createElement(
                    'strong',
                    null,
                    file.name
                  ),
                  ' ',
                  _react2.default.createElement(
                    _reactstrap.Badge,
                    { color: 'danger' },
                    (file.size / 1000).toFixed(1),
                    'kb'
                  )
                );
              })
            )
          ),
          _react2.default.createElement(
            _reactstrap.ModalFooter,
            null,
            _react2.default.createElement(
              _reactstrap.Button,
              { color: 'danger', onClick: toggleModal },
              cancelButtonText
            ),
            _react2.default.createElement(
              _reactstrap.Button,
              {
                color: 'success',
                onClick: onSave,
                disabled: accepted.length === 0 && rejected.length > 0 && true
              },
              confirmButtonText
            ),
            ' '
          )
        )
      );
    }
  }]);

  return MediaLibraryDropzone;
}(_react2.default.Component);

MediaLibraryDropzone.propTypes = {
  accepted: _propTypes2.default.array,
  rejected: _propTypes2.default.array,
  toggleModal: _propTypes2.default.func,
  modalStatus: _propTypes2.default.bool,
  onSave: _propTypes2.default.func,
  onDrop: _propTypes2.default.func,
  onClick: _propTypes2.default.func,
  multiple: _propTypes2.default.bool,
  uploadZoneIcon: _propTypes2.default.string,
  accept: _propTypes2.default.string,
  style: _propTypes2.default.object,
  dropZoneText: _propTypes2.default.string,
  confirmUploadTitle: _propTypes2.default.string,
  cancelButtonText: _propTypes2.default.string,
  confirmButtonText: _propTypes2.default.string,
  modalClassName: _propTypes2.default.string,
  rejectedFilesWarning: _propTypes2.default.string
};

MediaLibraryDropzone.defaultProps = {
  onSave: function onSave() {
    return null;
  },
  toggleModal: function toggleModal() {
    return null;
  },
  onDrop: function onDrop() {
    return null;
  },
  accepted: [],
  rejected: [],
  modalStatus: false,
  multiple: false,
  uploadZoneIcon: 'fas fa-cloud-upload-alt fa-5x',
  dropZoneText: 'Selecione os arquivos ou arraste para esta área',
  confirmUploadTitle: 'Confirmar o envio do(s) arquivo(s)?',
  cancelButtonText: 'Cancelar',
  confirmButtonText: 'Confirmar',
  modalClassName: 'modal-warning',
  rejectedFilesWarning: 'Os seguintes arquivos não poderão ser enviados por não se tratarem de um tipo de arquivo permitido:',
  style: {
    background: '#f8f8f8',
    border: '5px dashed #ddd',
    fontSize: '16px',
    color: '#ddd',
    width: '100%',
    height: '200px',
    textAlign: 'center',
    paddingTop: '25px'
  }
};

exports.default = MediaLibraryDropzone;